/* Simple Scanner v1.0
 ** Copyright (C) 2000 Ken Steen.
 **
 ** This program is free software; you can redistribute it and/or modify
 ** it under the terms of the GNU General Public License as published by
 ** the Free Software Foundation; either version 2 of the License, or
 ** (at your option) any later version.
 **
 ** This program is distributed in the hope that it will be useful,
 ** but WITHOUT ANY WARRANTY; without even the implied warranty of
 ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 ** GNU General Public License for more details.
 **
 ** You should have received a copy of the GNU General Public License
 ** along with this program; if not, write to the Free Software
 ** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 **/
#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <fcntl.h>
#include <sys/file.h>
#include <arpa/inet.h>

int scanning (int port);

struct sockaddr_in addr;
int sock, porta;
int x,y;
char *host_name;
char str_port[5];

GtkWidget *main_window;
GtkEntry *text1,*text2,*text3;
GtkStatusbar *statusbar;
GtkProgress *progressbar;
GtkCList *lista;
gchar *scan_info[3];
struct hostent *rh;


int scanning (int port)
{
    int r;

    sock = socket(PF_INET, SOCK_STREAM, IPPROTO_TCP);
    if (sock < 0) {
                    printf("ERROR: socket() failed\n");
		    exit(0);
	          }

    addr.sin_family = PF_INET;
    addr.sin_port = htons(port);
    addr.sin_addr = *((struct in_addr *)rh->h_addr);
    r = connect(sock,(struct sockaddr *) &addr, sizeof(addr));
    
    close(sock);
    if (r==-1) return 0; 
    else return 1;
}

void
on_Start_pressed                       (GtkButton       *button,
                                        gpointer         user_data)
{
    struct servent *s;
    int len;
    
    main_window = lookup_widget (GTK_WIDGET (button), "window1");
    text1 = (GtkEntry *) lookup_widget (GTK_WIDGET (main_window), "entry3");
    text2 = (GtkEntry *) lookup_widget (GTK_WIDGET (main_window), "entry5");
    text3 = (GtkEntry *) lookup_widget (GTK_WIDGET (main_window), "entry6");

    len = strlen ((char *) gtk_entry_get_text(text1));
    host_name = malloc (len);
    
    strcpy (host_name,(char *) gtk_entry_get_text(text1));

    if ((rh=gethostbyname(host_name)) == NULL){ exit(1); }
    x=atoi(gtk_entry_get_text(text2));
    y=atoi(gtk_entry_get_text(text3));

    if ( (x>y) || (x<0) || (y<0) || (x>65535) || (y>65535) ) return;
    
    statusbar = (GtkStatusbar *)lookup_widget (main_window, "statusbar1");
    progressbar = (GtkProgress *)lookup_widget (main_window, "progressbar1");
    lista = (GtkCList*) lookup_widget (GTK_WIDGET (main_window), "clist1");
    gtk_progress_configure (progressbar, (gfloat) x, (gfloat) x, (gfloat) y);

    gtk_clist_clear (lista);
			
    for(; x<= y; x++) {
	    gtk_progress_set_value(progressbar, x);
	    while (gtk_events_pending())
	    gtk_main_iteration();
	    if (scanning(x)) {
		    s = getservbyport(htons(x),"tcp");
	 	    sprintf(str_port,"%d",x);
	            scan_info[0]=(gchar *)str_port;
	            if (s == NULL) {
			    scan_info[1] = "unknown"; 
			    scan_info[2] = "unknown";
		    }
		    else
		    {
			    scan_info[1]=s->s_proto;
			    scan_info[2]=s->s_name;
		    }
		    gtk_clist_freeze(GTK_CLIST(lista));
		    gtk_clist_append (GTK_CLIST (lista), scan_info);
		    gtk_clist_thaw(GTK_CLIST(lista));
		    gtk_statusbar_push (GTK_STATUSBAR (statusbar), 1, "Scanning...");
	    }
    }
    gtk_statusbar_push (GTK_STATUSBAR (statusbar), 1, "Fine");
}


void
on_Stop_pressed                        (GtkButton       *button,
                                        gpointer         user_data)
{
    x=65536;
}

